package fr.test.ui;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JTextArea;

class EcouteurQuit implements ActionListener {

	@Override
	public void actionPerformed(ActionEvent e) {
		System.exit(0);
	}
	
}

class Ecouteur implements ActionListener {
	private JTextArea text;
	
	public Ecouteur(JTextArea uneZone) {
		text = uneZone;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		text.setText(text.getText()+"\n"+"Touché");
	}
	
}

public class TestUI {

	public static void main(String[] args) {
		JFrame fenetrePrincipale = new JFrame("Ma Superbe Application");
		
		Container panneau = fenetrePrincipale.getContentPane();
		
		JButton bouton1 = new JButton("Ok1");	
		JButton bouton2 = new JButton("Ok2");
		JButton bouton3 = new JButton("Ok3");
		JButton bouton4 = new JButton("Ok4");
		
		// Politique de rangement
		LayoutManager l = new BorderLayout();
		
		// Le panneau de la fenetre principale utilise la technique de rangement l
		panneau.setLayout(l);
		
		JPanel panneauInterne = new JPanel();
		panneauInterne.setLayout(new FlowLayout());
		panneauInterne.add(new JButton("B1"));
		panneauInterne.add(new JButton("B2"));
		JTextArea zoneTexte = new JTextArea(20,20);
		panneauInterne.add(zoneTexte);
		panneauInterne.add(new JScrollBar(JScrollBar.HORIZONTAL));
		
		panneau.add(bouton1,BorderLayout.NORTH);
		panneau.add(bouton2,BorderLayout.SOUTH);
		panneau.add(bouton3,BorderLayout.EAST);
		panneau.add(bouton4,BorderLayout.WEST);
		panneau.add(panneauInterne,BorderLayout.CENTER);	
		
		
		// Assemblage d'un menu
		JMenu menu = new JMenu("Fichier");
		JMenuItem open = new JMenuItem("Open");
		JMenuItem quit = new JMenuItem("Quit");
		menu.add(open);
		menu.add(quit);
		
		// Ajout dans la barre
		JMenuBar barreDeMenu = new JMenuBar();
		barreDeMenu.add(menu);
		
		// Placement de la barre dans la fenetre
		fenetrePrincipale.setJMenuBar(barreDeMenu);
		

		
		fenetrePrincipale.pack();
		fenetrePrincipale.setVisible(true);
		
		Ecouteur e = new Ecouteur(zoneTexte);
		bouton1.addActionListener(e);
		bouton2.addActionListener(e);
		
		EcouteurQuit quitter = new EcouteurQuit();
		quit.addActionListener(quitter);
	}

}
